1. 程式人生 > 實用技巧 >在a-table的基礎上實現拖拽功能 (封裝的元件)

在a-table的基礎上實現拖拽功能 (封裝的元件)

技術標籤:廣搜

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!

— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.

— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output
6
7
0
題意 把A變成B 變換過程的每個中間值 都必須是素數 因為是四位數 可以將每一位分離開 每一位都可以0-9取值

#include <iostream>
#include <algorithm>
#include <string.h>
#include <stdio.h>
#include<queue>
using namespace std;
const int N=10010;
int book[N],vis[N];
struct node
{
    int now,step;
};
void prime()
{
    memset(book,0,sizeof(book));
    book[1]=1;
    for(int i=2;i<N;i++)
    {
        if(!book[i])
        {
            for(int j=i*2;j<N;j+=i)
            {
                    book[j]=1;
            }
        }
    }
}
int bfs(int x,int y)
{
    int num;
    queue<node>Q;
    node  q,s;
    q.now=x;
    q.step=0;
     Q.push(q);
    while(!Q.empty())
    {
         q=Q.front();
        Q.pop();
        if(q.now==y)
            return q.step;
        int b[5];
        b[1]=q.now/1000;
        b[2]=q.now/100%10;
        b[3]=q.now/10%10;
        b[4]=q.now%10;
        for(int i=1;i<=4;i++)
        {
            int t=b[i];
            for(int j=0;j<=9;j++)
            {
                if(b[i]!=j)
                {
                    b[i]=j;
                    num=b[1]*1000+b[2]*100+b[3]*10+b[4];
                }
                if(num>=1000&&num<=9999&&vis[num]==0&&book[num]==0)
                {

                    vis[num]=1;
                    s.step=q.step+1;
                    s.now=num;
                     Q.push(s);
                }
            }
            b[i]=t;
        }
    }
    return -100;
}
int main()
{
    int n;
    prime();
    scanf("%d",&n);
    prime();
    while(n--)
    {
        int a,b;
        scanf("%d %d",&a,&b);
        memset(vis,0,sizeof(vis));
        int t=bfs(a,b);
        if(t!=-100)
            printf("%d\n",t);
        else
            printf("Impossible\n");

    }
}